#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <ctype.h>
#include <windows.h>
extern "C" {
#include <winmacro.h>
}

#define titlebufferlen 60
HWND ourwindow;
FARPROC OriginalWndProc;
char *booleanname[2] = {"FALSE","TRUE"};
char origtitlebuffer[titlebufferlen+1],titlebuffer[titlebufferlen+1];

void FAR PASCAL _export ShowMe();
LRESULT _export CALLBACK NewWndProc(HWND,UINT, WPARAM, LPARAM);
BOOLEAN vkey(UINT mkey);

void pause()
{
  printf("\nPress Enter to continue\n");
  while (!getch())  ;
}

void main()
{
  #define buflen 40
  #define maxmacros 10
  char choice[80];
  UINT mkey,mcnt;
  UINT ourhotkey;
  pTMacroContext far * mh;
  pTMacroRec mp;
  UINT version;
  LPSTR macrofilename = {"SREC.MCR"};
  char far *buf;
  HGLOBAL bufhglb;
  HGLOBAL mhhglb;

  bufhglb = GlobalAlloc(GMEM_SHARE, buflen+1);
  buf = GlobalLock(bufhglb);

  mhhglb = GlobalAlloc(GMEM_SHARE, sizeof(pTMacroContext));
  mh = (pTMacroContext far * )GlobalLock(mhhglb);

  version = GetWinmacroVersion();

  clrscr();
  // Now that clrscr() has set the EasyWin/Quickwin focus, get it's handle
  ourwindow=GetFocus();
  (*mh)=InstallHook(ourwindow,maxmacros,100,FALSE,TRUE,RMALL,MBWINDOW,TRUE);
  GetWindowText(ourwindow,origtitlebuffer,titlebufferlen);

 OriginalWndProc=(FARPROC)GetWindowLong(ourwindow,GWL_WNDPROC);
 SetWindowLong(ourwindow,GWL_WNDPROC,(LONG)NewWndProc);

  ourhotkey=MK_CTRLF10;

  do {
  printf("SREC macro demonstation program for C.  WINMACRO.DLL version %d.%d\n\n", HIBYTE(version),LOBYTE(version));
  printf("Scrap macro=%Fs,  ",GetKeyName(GetMacroKey(GetMacroByIndex(*mh,-1)),buf,buflen));
  printf("Cancel playback/record=%Fs\n",GetKeyName(GetCancelKey(),buf,buflen));
  printf("Pause/resume record=%Fs, ",GetKeyName(GetPauseKey(),buf,buflen));
  printf("Toggle record=%Fs\n",GetKeyName(GetToggleRecordKey(),buf,buflen));
  printf("Current hot key=%Fs\n\n",GetKeyName(ourhotkey,buf,buflen));
  puts("1. Copy the current scrap macro to a macro assigned to the current hotkey");
  puts("2. Display the status of the shift bits in the current hotkey");
  puts("3. Set the Alt bit in the current hotkey/macro");
  puts("4. Turn recording on");
  puts("5. Turn recording off");
  puts("6. List all available macros");
  puts("7. Get a macro's name using its hotkey to look it up");
  puts("8. Install a code macro to re-display this Window when Ctrl+F9 is pressed");
  printf("\nA. Write macros to file %s\n",macrofilename);
  printf("B. Read macros from file %s\n",macrofilename);
  puts("\nC. List all possible macro keys to the screen\n");
  puts("\nQ. Quit\n");
  puts("Enter a choice, please ");
  scanf("%s",&choice);
  choice[0]=toupper(choice[0]);

  switch (choice[0]) {
  case '1': {
				 InstallMacro(*mh,ourhotkey,GetScrapMacro(),"Key macro originally assigned to Ctrl+F10",0);
				 break;
				}
  case '2': {
				  printf("Control bit=%s, Alt bit=%s, Shift bit=%s\n",
				  booleanname[GetKeyCtrl(ourhotkey)],booleanname[GetKeyAlt(ourhotkey)],
				  booleanname[GetKeyShift(ourhotkey)]);
				  pause();
				  break;
				}
  case '3': {
				  mp=GetMacroByKey(*mh,ourhotkey);
				  SetKeyAlt(&ourhotkey,TRUE);
				  SetMacroKey(mp,ourhotkey);
				  break;
				}
  case '4': {RecordingOn(); break;}
  case '5': {RecordingOff(); break;}
  case '6': {for (mcnt=0; mcnt<maxmacros; ++mcnt) {
					mp=GetMacroByIndex(*mh,mcnt);
					if (mp) printf("Hotkey=%Fs Name=%Fs\n",GetKeyName(GetMacroKey(mp),buf,buflen),GetMacroName(mp));
					}
					pause();
					break;
				}
  case '7': {
				  printf("Name of macro assigned to %Fs is %Fs\n",GetKeyName(ourhotkey,buf,buflen),
				  GetMacroName(GetMacroByKey(*mh,ourhotkey)));
				  pause();
				  break;
				}
  case '8':  {
					ourwindow=GetFocus();
					InstallMacro(*mh,MK_CTRLF9,GetScrapMacro(),"Code macro assigned to Ctrl+F9",ShowMe);
					break;
				 }
  case 'A' : {WriteMacros(*mh,macrofilename); break;}
  case 'B' : {ReadMacros(*mh,macrofilename,TRUE); break;}
  case 'C' : {int maxkeys=GetMaxPossibleMKeys();
					for (UINT kcnt=0; kcnt<maxkeys; ++kcnt)
					{
						mkey=GetPossibleMKey(kcnt);
						printf("%Fs\t",GetKeyName(mkey,buf,buflen));
					}
					pause();
					break;
				}
  }
  clrscr();
  SetWindowText(ourwindow,origtitlebuffer);
  } while (choice[0] !='Q');


  UninstallHook(mh);
  GlobalUnlock(bufhglb);
  GlobalFree(bufhglb);
  GlobalUnlock(mhhglb);
  GlobalFree(mhhglb);
}


void FAR PASCAL _export ShowMe()
{
  PostMessage(ourwindow, WM_SYSCOMMAND, SC_HOTKEY, ourwindow);
  PostMessage(ourwindow, WM_SYSCOMMAND, SC_RESTORE, ourwindow);
}

LRESULT _export CALLBACK NewWndProc(HWND hwnd,UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  LRESULT rval;
  switch (uMsg) {
  case MM_RECORDOFF : {
									 SetWindowText(ourwindow,"RECORD=OFF");
									 rval=1;
									 break;
								 }
  case MM_RECORDON : {
									 SetWindowText(ourwindow,"RECORD=ON");
									 rval=1;
									 break;
								 }
  case MM_PLAYBACKOFF : {
									 SetWindowText(ourwindow,"PLAYBACK=OFF");
									 rval=1;
									 break;
								 }
  case MM_PLAYBACKON : {
									 SetWindowText(ourwindow,"PLAYBACK=ON");
									 rval=1;
									 break;
								 }
  default : rval=CallWindowProc(OriginalWndProc,hwnd, uMsg, wParam, lParam);
  }
  return(rval);
}


